// Author: Solution to Lab 3
// Course: CMPU102
// Date:   2/13/17
//
// This class represents a human being.  There are 4 
// private instance variables and one class (static) 
// variable.

// The Person class is instantiable, with one 3-parameter
// constructor

class Person {
    
    // instance variables
    String lastName;
    int age;
    char gender;
    int number;
    
    // public class variable
    public static int counter = 0;
    
    // 3-parameter constructor sets values for 3 instance variables
    // and computes value for the number instance variable.
    public Person(String lastName, int age, char gender) {
        this.lastName = lastName;  
        this.age = age;   
        this.gender = gender;     
        counter++;        // increment static counter
        this.number = counter; // Set the number instance variable in
                          // current object
    } // end constructor
    
    
    // Returns value of the age instance variable
    public int getAge() { 
        return age;
    } // end getAge
    
    // Returns value of the lastName instance variable
    public String getLastName() { 
        return lastName;
    } // end getLastName
    
    // Returns value of the gender instance variable
    public char getGender(){  
        return gender;
    } // end getGender
    
    // Return a String representation of the object
    public String toString() {  
        return ("\nPerson "+number+": "+lastName + "\t\t"+
                age+"\t\t"+gender);
    } // end toString 
    
    // Check if this object is equal to the object passed in.
    // Note: Input type should be Person, not Object
    public boolean equals(Person p2) {
        return this.lastName.equals(p2.lastName) &&
            this.age == p2.age &&
            this.gender == p2.gender;
    }   
}
